<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgAnalyticszoo10 extends JPlugin
{
	function plgAnalyticszoo10( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
    function onGetChartTypes(&$data, $name) 
	{
		if ( $name != 'zoo10' ) return;
		
		$data = array( 'amcolumn');
	}

	function onDrawChart(&$objChart, $name, &$params)
	{
		if($name != 'zoo10') return;

		global $mainframe;

		if( !JComponentHelper::isEnabled('com_zoo', true) ) {
			$errors = '<h3>ZOO Component Not Exists or Not Enabled<h3>';
			return;
		}

	    $mparams = JComponentHelper::getParams('com_analytics');

		$objChart->setConfig('width',$mparams->get('width', 770));
		$objChart->setConfig('height',$params->get('height', 400));
		$objChart->setConfig('background.alpha',"1");
		$objChart->setConfig('preloader_color',"#999999");
		$objChart->addLabel("<![CDATA[<b>Top items by types</b>]]>",15 ,25 , array('text_size' => 16));
	}
	
    function onGetForm(&$form, $name, $report, $params) 
	{
		if( $name != 'zoo10' ) return;
		
		$report_params = new JParameter($report->params, JPATH_ROOT.DS.'plugins'.DS.'analytics'.DS.$params->get('type').'.xml');
		
		$group = 'Advanced params';
		
		if (!isset($report_params->_xml[$group])) {
			return false;
		}
		$elements= $report_params->renderToArray('params', $group);
		
		$doc = &JFactory::getDocument();
		$doc->addStyleDeclaration('
			.label {
				text-align: right;
				height: 30px;
			}
			.field select {
				width: 13em;
			}
		');
		
		$form .= '<table cellspacing="2" cellpadding="2">';
		if ($description = $report_params->_xml[$group]->attributes('description')) {
			// add the params description to the display
			$desc	= JText::_($description);
			$form .= '<tr><td class="paramlist_description" colspan="2">'.$desc.'</td></tr>';
		}
		foreach ($elements as $key => $element)
		{
			$form .= '<tr>';

			if ($element[0]) {
				$form .= '<td class="label"><span class="editlinktip">'.$element[0].'</span></td>';
				$form .= '<td  class="inputbox field">'.$element[1].'</td>';
			} else {
				$form .= '<td  class="inputbox field" colspan="2">'.$element[1].'</td>';
			}

			$form .= '</tr>';
		}
		if (count($element) < 1) {
			$form .= "<tr><td colspan=\"2\"><i>".JText::_('There are no Parameters for this item')."</i></td></tr>";
		}
		$form .= '</table>';
	}

	function onChartData( &$objChart, $name, $params )
	{

		if($name != 'zoo10') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$type       = $params->get( 'types' );
		$criteria  = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max        = $params->get( 'max', 20 );
		$reverse    = $params->get( 'reverse', 'DESC' );

		if( !$type ) return;

		if( !is_array( $type ) ) {
			$type = Array( $type );
		}

	    switch( $criteria ) {
			case 'rating_average':
			case 'rating_count':
				$time_criterion = "r.created";
				break;
			case 'comments':
				$time_criterion = "co.created";
				break;
			case 'hits':
				$time_criterion = "i.created";
				break;
		}
		
	    switch ( $criteria ) {
			case 'hits':
			   $sql = "    SELECT i.id, i.name AS title, i.hits AS amount"
        		."\n  FROM #__zoo_item AS i "
        		."\n      WHERE i.state =  1 AND i.hits > 0 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
			
			case 'rating_count':
			    $sql = "    SELECT i.id, i.name AS title, Count(r.id) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
			
			case 'rating_average':
			    $sql = "    SELECT i.id, i.name AS title, (sum(r.value)/Count(r.id)) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
			
			case 'comments':
			    $sql = "    SELECT i.id, i.name AS title, Count(co.id) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_comment AS co ON i.id = co.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
		}

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;

	    foreach ( $result AS $row ) {
			$objChart->addSerie($row->id,$row->title);
			$objChart->addGraph($row->id, $row->title, array($row->id => $row->amount), array( 
					'balloon_text' => '<![CDATA[<b>{value}</b> {series}]]>'
				));
		}
	}

	function onDrawTable(&$table, $name, $params)
	{
		if($name != 'zoo10') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');
		
		$type       = $params->get( 'types' );
		$criteria  = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max        = $params->get( 'max', 20 );
		$reverse    = $params->get( 'reverse', 'DESC' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		if( !$type ) return;

		if( !is_array( $type ) ) {
			$type = Array( $type );
		}
	    
		switch( $criteria ) {
			case 'rating_average':
			case 'rating_count':
				$time_criterion = "r.created";
				break;
			case 'comments':
				$time_criterion = "co.created";
				break;
			case 'hits':
				$time_criterion = "i.created";
				break;
		}

	    switch ( $criteria ) {
			case 'hits':
			   $sql = "    SELECT i.id, i.name AS title, i.hits AS amount"
        		."\n  FROM #__zoo_item AS i "
        		."\n      WHERE i.state =  1 AND i.hits > 0 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
			
			case 'rating_count':
			    $sql = "    SELECT i.id, i.name AS title, Count(r.id) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
			
			case 'rating_average':
			    $sql = "    SELECT i.id, i.name AS title, (sum(r.value)/Count(r.id)) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
			
			case 'comments':
			    $sql = "    SELECT i.id, i.name AS title, Count(co.id) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_comment AS co ON i.id = co.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		$sql .= " GROUP BY i.id"
        		."\n   ORDER BY amount ".$reverse
        		."\n      LIMIT 0, ".$max;
			break;
		}

		$db->setQuery( $sql );
		$result = $db->loadObjectList();

		if( !$result ) return;
		
		$data_label = array( 'rating_average' => JText::_('Rating (avarage)'),
		                     'rating_count'   => JText::_('Rating (count)'),
		                     'comments'       => JText::_('Comments'),
		                     'hits'           => JText::_('Hits') );

		$k                  = 0;
		$current_total      = 0;

		$out[] = '<table class="adminlist" cellspacing="0">';
		$out[] = '<thead>';
		$out[] = '<tr>';
		$out[] = '<th width="1%">#</th>';
		$out[] = '<th class="title">'.JText::_('Type').'</th>';
		$out[] = '<th width="1%">'.$data_label[$criteria].'</th>';
		$out[] = '</tr>';
		$out[] = '</thead>';
		$out[] = '<tbody>';

		foreach ( $result AS $row ) {
			$slices[$row->id]['name'] = $row->title;
			$slices[$row->id]['amount'] = $row->amount;
		}

		$k = 1;
		$i = 1;
		foreach ( $slices AS $key => $slice ) {

			$current_total += $slice['amount'];

			$k = 1 - $k;

			$out[] = sprintf( "<tr class='row%d'><td>%d</td><td nowrap>%s</td><td align='right'>%s</td></tr>",
			$k, $i, $slice['name'], $slice['amount']
			);
			$i++;
		}
		$out[] = sprintf( "<tr class='row%d'><td></td><td nowrap><big><b>%s</b></big></td><td align='right'><big><b>%s</b></big></td></tr>",
				0, JText::_('Total'), $current_total );

		$out[] = '</tbody></table>';

		$table = implode( "", $out );

		if( $params->get( 'rep_xls' ) )
		{
			jimport('joomla.filesystem.file');
			$file = JPATH_ROOT.DS.'cache'.DS.$user->id.DS.$name.'.xls';
			JFile::write($file, $table);
		}

	}

	function onGetTotals($name, $params)
	{
		if($name != 'zoo10') return;

		$db = JFactory::getDBO();
		$user = JFactory::getUser();
		$user_id = $params->get('user_id');

		$type       = $params->get( 'types' );
		$criteria = $params->get( 'criteria' );
		$from       = $params->get( 'start',  date('Y-m-d H:s:i', mktime( 0,  0,  0,  date( 'm' )-1, date('d' ), date( 'Y' ) ) ) );
		$to         = $params->get( 'finish', date('Y-m-d H:s:i', mktime( 23, 59, 59, date( 'm' ),   date('d' ), date( 'Y' ) ) ) );
		$max        = $params->get( 'max', 20 );
		$reverse    = $params->get( 'reverse', 'DESC' );
		$sort_by = $params->get('sort_by');
		$limit = $params->get('limit', 0);

		if( !$type ) return;

		if( !is_array( $type ) ) {
			$type = Array( $type );
		}
		
		switch( $criteria ) {
			case 'rating_average':
			case 'rating_count':
				$time_criterion = "r.created";
				break;
			case 'comments':
				$time_criterion = "co.created";
				break;
			case 'hits':
				$time_criterion = "i.created";
				break;
		}
		
	    switch ( $criteria ) {
			case 'hits':
			   $sql = "    SELECT sum(i.hits) AS amount, count(i.id) AS rec_count "
        		."\n  FROM #__zoo_item AS i "
        		."\n      WHERE i.state =  1 AND i.hits >  0 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		
        		$sql_total = "    SELECT sum(i.hits) AS amount"
        		."\n  FROM #__zoo_item AS i "
        		."\n      WHERE i.state =  1 AND i.hits >  0 AND i.type IN('".implode( "', '", $type )."') ";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql_total .= " AND i.created_by = '$user_id'";
			break;
			
			case 'rating_count':
			    $sql = "    SELECT Count(r.id) AS amount, count(i.id) AS rec_count"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		
        		$sql_total = "    SELECT Count(r.id) AS amount "
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') ";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql_total .= " AND i.created_by = '$user_id'";
			break;
			
			case 'rating_average':
			    $sql = "    SELECT (sum(r.value)/Count(r.id)) AS amount, count(i.id) AS rec_count"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
        		
        		$sql_total = "    SELECT (sum(r.value)/Count(r.id)) AS amount "
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_rating AS r ON i.id = r.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') ";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql_total .= " AND i.created_by = '$user_id'";
			break;
			
			case 'comments':
			    $sql = "    SELECT Count(co.id) AS amount, count(i.id) AS rec_count"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_comment AS co ON i.id = co.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql .= " AND i.created_by = '$user_id'";
            		
            	$sql_total = "    SELECT Count(co.id) AS amount"
        		."\n  FROM #__zoo_item AS i
        		Inner Join #__zoo_comment AS co ON i.id = co.item_id "
        		."\n      WHERE i.state = 1 AND i.type IN('".implode( "', '", $type )."') AND ".$time_criterion." BETWEEN '{$from}' AND '{$to}'";
        		if(($params->get('user_stick') && $user_id) || ($user->gid == 25 && $user_id))
            		$sql_total .= " AND i.created_by = '$user_id'";
			break;
		}
		
		$db->setQuery( $sql );
		$result = $db->loadObject();

		if( !$result ) return;
		
		$db->setQuery( $sql_total ); 
		$total = $db->loadResult();
		
		$sql2 = "  SELECT COUNT(i.id) AS amount"
		."\n  FROM #__zoo_item AS i"
		."\n  WHERE i.state = 1 ";
		
		$db->setQuery( $sql2 );
		$dbtotal_records = $db->loadResult();
		
		if(!$dbtotal_records) return;
		
		$totals = array();
		
		$data_label = array( 'rating_average' => JText::_('rating (avarage)'),
		                     'rating_count'   => JText::_('rating (count)'),
		                     'comments'       => JText::_('comments'),
		                     'hits'           => JText::_('hits') );
		$text = $data_label[$criteria];

		$totals[0]['value'] = $dbtotal_records.' <i>'.JText::_( 'record(s)').'</i>';
		$totals[0]['text'] = JText::_('Total in DB');
		
		$totals[1]['value'] = $result->rec_count.' <i><b>'.JText::_( 'current record(s)' ).'</b></i>';
		$totals[1]['text'] = round($result->rec_count * 100 / $dbtotal_records, 1).'% '.JText::_('of all records');
		
		$totals[2]['value'] = $total;
		$totals[2]['text'] = JText::_('Total').' '.$text;
		
		$totals[3]['value'] = $result->amount.' <i><b>'.JText::_( 'current' ).' '.$text.'</b></i>';
		$totals[3]['text'] = round($result->amount * 100 / $total, 1).'% '.JText::_('of all').' '.$text;
	
		return $totals;
	}
}
?>